Index: kernel/arch/ia64/src/drivers/ski.c
===================================================================
--- kernel/arch/ia64/src/drivers/ski.c	(revision 103db9089df98061a5560c2c731e082f1f964f94)
+++ kernel/arch/ia64/src/drivers/ski.c	(revision 04c35fcac1c020178f0c05da7cda7fd1292902cc)
@@ -37,4 +37,5 @@
 #include <console/console.h>
 #include <console/chardev.h>
+#include <ddi/ddi.h>
 #include <sysinfo/sysinfo.h>
 #include <stdint.h>
@@ -69,4 +70,5 @@
 
 static ski_instance_t *instance = NULL;
+static parea_t ski_parea;
 
 /** Ask debug console if a key was pressed.
@@ -105,4 +107,7 @@
 	int count = POLL_LIMIT;
 
+	if (ski_parea.mapped)
+		return;
+
 	while (count > 0) {
 		wchar_t ch = ski_getchar();
@@ -122,10 +127,5 @@
 
 	while (true) {
-		// TODO FIXME:
-		// This currently breaks the kernel console
-		// before we get the override from uspace.
-		if (console_override)
-			poll_keyboard(instance);
-
+		poll_keyboard(instance);
 		thread_usleep(POLL_INTERVAL);
 	}
@@ -140,4 +140,6 @@
 static void ski_init(void)
 {
+	uintptr_t faddr;
+
 	if (instance)
 		return;
@@ -150,4 +152,17 @@
 	    : "r15", "r8"
 	);
+
+	faddr = frame_alloc(1, FRAME_LOWMEM | FRAME_ATOMIC, 0);
+	if (faddr == 0)
+		panic("Cannot allocate page for ski console.");
+
+	ddi_parea_init(&ski_parea);
+	ski_parea.pbase = faddr;
+	ski_parea.frames = 1;
+	ski_parea.unpriv = false;
+	ski_parea.mapped = false;
+	ddi_parea_register(&ski_parea);
+
+	sysinfo_set_item_val("ski.paddr", NULL, (sysarg_t) faddr);
 
 	instance = malloc(sizeof(ski_instance_t));
@@ -190,16 +205,14 @@
 static void ski_putwchar(outdev_t *dev, wchar_t ch)
 {
-	// TODO FIXME:
-	// This currently breaks the kernel console
-	// before we get the override from uspace.
-	if (console_override) {
-		if (ascii_check(ch)) {
-			if (ch == '\n')
-				ski_do_putchar('\r');
-
-			ski_do_putchar(ch);
-		} else {
-			ski_do_putchar('?');
-		}
+	if (ski_parea.mapped)
+		return;
+
+	if (ascii_check(ch)) {
+		if (ch == '\n')
+			ski_do_putchar('\r');
+
+		ski_do_putchar(ch);
+	} else {
+		ski_do_putchar('?');
 	}
 }
Index: kernel/generic/include/mm/as.h
===================================================================
--- kernel/generic/include/mm/as.h	(revision 103db9089df98061a5560c2c731e082f1f964f94)
+++ kernel/generic/include/mm/as.h	(revision 04c35fcac1c020178f0c05da7cda7fd1292902cc)
@@ -268,5 +268,4 @@
 
 extern as_t *as_create(unsigned int);
-extern void as_destroy(as_t *);
 extern void as_hold(as_t *);
 extern void as_release(as_t *);
Index: kernel/generic/src/console/console.c
===================================================================
--- kernel/generic/src/console/console.c	(revision 103db9089df98061a5560c2c731e082f1f964f94)
+++ kernel/generic/src/console/console.c	(revision 04c35fcac1c020178f0c05da7cda7fd1292902cc)
@@ -209,4 +209,5 @@
 void grab_console(void)
 {
+	sysinfo_set_item_val("kconsole", NULL, true);
 	event_notify_1(EVENT_KCONSOLE, false, true);
 	bool prev = console_override;
@@ -226,4 +227,5 @@
 void release_console(void)
 {
+	sysinfo_set_item_val("kconsole", NULL, false);
 	console_override = false;
 	event_notify_1(EVENT_KCONSOLE, false, false);
Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision 103db9089df98061a5560c2c731e082f1f964f94)
+++ kernel/generic/src/mm/as.c	(revision 04c35fcac1c020178f0c05da7cda7fd1292902cc)
@@ -187,5 +187,5 @@
  *
  */
-void as_destroy(as_t *as)
+static void as_destroy(as_t *as)
 {
 	DEADLOCK_PROBE_INIT(p_asidlock);
Index: kernel/generic/src/proc/program.c
===================================================================
--- kernel/generic/src/proc/program.c	(revision 103db9089df98061a5560c2c731e082f1f964f94)
+++ kernel/generic/src/proc/program.c	(revision 04c35fcac1c020178f0c05da7cda7fd1292902cc)
@@ -150,5 +150,5 @@
 	prg->loader_status = elf_load((elf_header_t *) image_addr, as);
 	if (prg->loader_status != EE_OK) {
-		as_destroy(as);
+		as_release(as);
 		prg->task = NULL;
 		prg->main_thread = NULL;
@@ -176,5 +176,5 @@
 	void *loader = program_loader;
 	if (!loader) {
-		as_destroy(as);
+		as_release(as);
 		log(LF_OTHER, LVL_ERROR,
 		    "Cannot spawn loader as none was registered");
@@ -184,5 +184,5 @@
 	prg->loader_status = elf_load((elf_header_t *) program_loader, as);
 	if (prg->loader_status != EE_OK) {
-		as_destroy(as);
+		as_release(as);
 		log(LF_OTHER, LVL_ERROR, "Cannot spawn loader (%s)",
 		    elf_error(prg->loader_status));
Index: uspace/drv/char/ski-con/ski-con.c
===================================================================
--- uspace/drv/char/ski-con/ski-con.c	(revision 103db9089df98061a5560c2c731e082f1f964f94)
+++ uspace/drv/char/ski-con/ski-con.c	(revision 04c35fcac1c020178f0c05da7cda7fd1292902cc)
@@ -1,5 +1,5 @@
 /*
  * Copyright (c) 2005 Jakub Jermar
- * Copyright (c) 2017 Jiri Svoboda
+ * Copyright (c) 2018 Jiri Svoboda
  * All rights reserved.
  *
@@ -31,7 +31,9 @@
  */
 
+#include <as.h>
 #include <async.h>
 #include <ddf/driver.h>
 #include <ddf/log.h>
+#include <ddi.h>
 #include <errno.h>
 #include <fibril.h>
@@ -40,4 +42,5 @@
 #include <stdlib.h>
 #include <stdbool.h>
+#include <sysinfo.h>
 
 #include "ski-con.h"
@@ -68,4 +71,6 @@
 	ddf_fun_t *fun = NULL;
 	bool bound = false;
+	uintptr_t faddr;
+	void *addr = AS_AREA_ANY;
 	errno_t rc;
 
@@ -87,4 +92,18 @@
 	con->cds.sarg = con;
 
+	rc = sysinfo_get_value("ski.paddr", &faddr);
+	if (rc != EOK)
+		faddr = 0; /* No kernel driver to arbitrate with */
+
+	if (faddr != 0) {
+		addr = AS_AREA_ANY;
+		rc = physmem_map(faddr, 1, AS_AREA_READ | AS_AREA_CACHEABLE,
+		    &addr);
+		if (rc != EOK) {
+			ddf_msg(LVL_ERROR, "Cannot map kernel driver arbitration area.");
+			goto error;
+		}
+	}
+
 	rc = ddf_fun_bind(fun);
 	if (rc != EOK) {
@@ -107,4 +126,6 @@
 	return EOK;
 error:
+	if (addr != AS_AREA_ANY)
+		as_area_destroy(addr);
 	if (bound)
 		ddf_fun_unbind(fun);
@@ -127,4 +148,26 @@
 }
 
+/** Detect if SKI console is in use by the kernel.
+ *
+ * This is needed since the kernel has no way of fencing off the user-space
+ * driver.
+ *
+ * @return @c true if in use by the kernel.
+ */
+static bool ski_con_disabled(void)
+{
+	sysarg_t kconsole;
+
+	/*
+	 * XXX Ideally we should get information from our kernel counterpart
+	 * driver. But there needs to be a mechanism for the kernel console
+	 * to inform the kernel driver.
+	 */
+	if (sysinfo_get_value("kconsole", &kconsole) != EOK)
+		return false;
+
+	return kconsole != false;
+}
+
 /** Poll Ski for keypresses. */
 static errno_t ski_con_fibril(void *arg)
@@ -135,5 +178,5 @@
 
 	while (true) {
-		while (true) {
+		while (!ski_con_disabled()) {
 			c = ski_con_getchar();
 			if (c == 0)
@@ -246,6 +289,9 @@
 	uint8_t *dp = (uint8_t *) data;
 
-	for (i = 0; i < size; i++)
-		ski_con_putchar(con, dp[i]);
+	if (!ski_con_disabled()) {
+		for (i = 0; i < size; i++) {
+			ski_con_putchar(con, dp[i]);
+		}
+	}
 
 	*nwr = size;
Index: uspace/drv/char/ski-con/ski-con.h
===================================================================
--- uspace/drv/char/ski-con/ski-con.h	(revision 103db9089df98061a5560c2c731e082f1f964f94)
+++ uspace/drv/char/ski-con/ski-con.h	(revision 04c35fcac1c020178f0c05da7cda7fd1292902cc)
@@ -56,4 +56,6 @@
 	fibril_mutex_t buf_lock;
 	fibril_condvar_t buf_cv;
+	/** Memory area mapped to arbitrate with the kernel driver */
+	void *mem_area;
 } ski_con_t;
 
Index: uspace/lib/c/generic/loader.c
===================================================================
--- uspace/lib/c/generic/loader.c	(revision 103db9089df98061a5560c2c731e082f1f964f94)
+++ uspace/lib/c/generic/loader.c	(revision 04c35fcac1c020178f0c05da7cda7fd1292902cc)
@@ -200,5 +200,5 @@
 	}
 
-	rc = loader_set_program(ldr, path, fd);
+	rc = loader_set_program(ldr, abspath, fd);
 	vfs_put(fd);
 	return rc;
